<html lang="en">
<head>
<title>Minor Display Modes - Speedbar: File/Tag summarizing utility</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Speedbar: File/Tag summarizing utility">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="up" href="Extending.html#Extending" title="Extending">
<link rel="prev" href="Extending.html#Extending" title="Extending">
<link rel="next" href="Major-Display-Modes.html#Major-Display-Modes" title="Major Display Modes">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Minor-Display-Modes"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Major-Display-Modes.html#Major-Display-Modes">Major Display Modes</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Extending.html#Extending">Extending</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="Extending.html#Extending">Extending</a>
<hr>
</div>

<h3 class="section">7.1 Minor Display Modes</h3>

<p><a name="index-create-minor-display-mode-67"></a>
A <dfn>minor display mode</dfn> is a mode useful when using a specific type of
buffer.  This mode might not be useful for any other kind of data or
mode, or may just be more useful that a files or buffers based mode when
working with a specialized mode.

   <p>Examples that already exist for speedbar include RMAIL, Info, and gdb. 
These modes display information specific to the major mode shown in the
attached frame.

   <p>To enable a minor display mode in your favorite Major mode, follow these
steps.  The string `<samp><var>name</var></samp>' is the name of the major mode being
augmented with speedbar.

     <ol type=1 start=1>
<li>Create the keymap variable <var>name</var><code>-speedbar-key-map</code>.

     <li>Create a function, named whatever you like, which assigns values into your
keymap.  Use this command to create the keymap before assigning
bindings:

     <pre class="smallexample">              (setq <var>name</var>-speedbar-key-map (speedbar-make-specialized-keymap))
     </pre>
     <p>This function creates a special keymap for use in speedbar.

     <li>Call your install function, or assign it to a hook like this:

     <pre class="smallexample">          (if (featurep 'speedbar)
              (<var>name</var>-install-speedbar-variables)
            (add-hook 'speedbar-load-hook '<var>name</var>-install-speedbar-variables))
     </pre>
     <li>Create an easymenu compatible vector named
<var>name</var><code>-speedbar-menu-items</code>.  This will be spliced into
speedbar's control menu.

     <li>Create a function called <var>name</var><code>-speedbar-buttons</code>.  This function
should take one variable, which is the buffer for which it will create
buttons.   At this time <code>(current-buffer)</code> will point to the
uncleared speedbar buffer.
        </ol>

   <p>When writing <var>name</var><code>-speedbar-buttons</code>, the first thing you will
want to do is execute a check to see if you need to re-create your
display.  If it needs to be cleared, you need to erase the speedbar
buffer yourself, and start drawing buttons.  See <a href="Creating-a-display.html#Creating-a-display">Creating a display</a>.

   </body></html>

